{

files.bbs processing engine
(c) part of rMp3Tag
(c) 1999-200 by raVen

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rFBBS;
interface
Uses Objects, rObjects;
{}
type
{( tStringObj )}
 pStringObj = ^tStringObj;
 tStringObj = object(tObject)
  st: PString;
  constructor init(ast: String);
  destructor  done; virtual;
 end;
{( tDesc )}
 pDesc = ^tDesc;
 tDesc = object(tObject)
  FileName: pString;
  DescLines: prCollection;
  constructor init(aWord1: String);
  destructor  done; virtual;
  procedure   InsertDescLine(s: string);
 end;
{( tDescCol )}
 pDescCol = ^tDescCol;
 tDescCol = object(tSortedCollection)
  Link: pStream;
  function    Compare(Key1,Key2: Pointer): Integer; virtual;
  procedure   Insert(Item: Pointer); virtual;
  function    Load(FileName,LongDesc: String): Byte;
  function    Save(FileName,LongDesc: String): Byte;
 end;
{}
implementation
Uses rStrings, rCommon;
{( tStringObj )}
constructor tStringObj.init;
 begin
  inherited init;
  st:=NewStr(ast);
 end;
{}
destructor  tStringObj.done;
 begin
  if st<>nil then DisposeStr(st);
  inherited done;
 end;
{( tDesc )}
constructor tDesc.init;
 begin
  inherited init;
  New(DescLines,Init(16,16));
  if Pos(' ',aWord1)>0 then aWord1:='"'+aWord1+'"';
  FileName:=NewStr(aWord1);
 end;
{}
destructor  tDesc.done;
 begin
  if FileName<>nil then DisposeStr(FileName);
  DisposeObj(DescLines);
  inherited done;
 end;
{}
procedure   tDesc.InsertDescLine;
 begin
  DescLines^.Insert(New(pStringObj,Init(s)));
 end;
{( tDescCol )}
function    tDescCol.Compare;
 var
  q1: pDesc absolute Key1;
  q2: pDesc absolute Key2;
  s1,s2: String;
 begin
  s1:=UpStr(GetPS(pDesc(Key1)^.FileName));
  s2:=UpStr(GetPS(pDesc(Key2)^.FileName));
  if s1<s2 then Compare:=-1
  else if s1=s2 then Compare:=0
  else if s1>s2 then Compare:=1;
 end;
{}
procedure   tDescCol.Insert;
 var
  I: Integer;
  b: Boolean;
 begin
  b:=Search(Item,I);
  if b and Duplicates then AtFree(I);
  if not b or Duplicates then AtInsert(I,Item) else FreeItem(Item);
 end;
{}
function    tDescCol.Load;
 var
  s: string;
  p: Byte;
  Desc: pDesc;
 begin
  Load:=1;
  FreeAll;
  if not Exist(FileName) then exit;
  Link:=New(pBufStream,Init(FileName,stOpenRead,BlockSize));
  desc:=nil;
  repeat
   StreamReadLn(Link^,s);
   TrimStart(s,['"']);
   p:=Pos('"',s);
   if p=0 then p:=Pos(' ',s);
   if (Pos(LongDesc,s)<>1) or (p=0) then
    begin
     if Desc<>nil then Insert(Desc);
     New(Desc,Init(Copy(s,1,p-1)));
     Desc^.InsertDescLine(Copy(s,p+1,Length(s)));
    end else Desc^.InsertDescLine(Copy(s,Length(LongDesc)+1,Length(s)));
  until (Link^.Status<>stOK) or (Link^.GetPos=Link^.GetSize);
  if Desc<>nil then Insert(Desc);
  DisposeObj(Link);
  Load:=0;
 end;
{}
function    tDescCol.Save;
 const
  crlf: Array[1..2] of Char = #13#10;
  space: Char = ' ';
 var
  x,y: Integer;
  Desc: pDesc;
  s: String;
 begin
  Save:=1;
  Link:=New(pBufStream,Init(FileName,stCreate,BlockSize));
  if Count>0 then for x:=0 to Count-1 do
   begin
    Desc:=At(x);
    s:=GetPS(Desc^.FileName);
    Link^.Write(s[1],Length(s));
    Link^.Write(space,1);
    if Desc^.DescLines^.Count>0 then for y:=0 to Desc^.DescLines^.Count-1 do
     begin
      if y<>0 then Link^.Write(LongDesc[1],Length(LongDesc));
      if pStringObj(Desc^.DescLines^.At(y))^.st<>nil then StreamWriteLn(Link^,GetPS(pStringObj(Desc^.DescLines^.At(y))^.st),
      cr+lf)
      else StreamWriteLn(Link^,'',cr+lf);
     end else Link^.Write(crlf,2);
   end;
  DisposeObj(Link);
  Save:=0;
 end;
{}
end.
